aboutsummaryrefslogtreecommitdiffstats
path: root/main
diff options
context:
space:
mode:
authorNatanael Copa <ncopa@alpinelinux.org>2013-04-24 13:30:14 +0000
committerNatanael Copa <ncopa@alpinelinux.org>2013-04-24 13:56:14 +0000
commit5a33772c28df0da100009ea671151f7e2c9655fc (patch)
treeef12e74f53ce45190af8fb90471312572af9e269 /main
parent8d87ec68389b741072a10feef59462edc468349b (diff)
downloadaports-5a33772c28df0da100009ea671151f7e2c9655fc.tar.bz2
aports-5a33772c28df0da100009ea671151f7e2c9655fc.tar.xz
main/libarchive: security fix (CVE-2013-0211)
fixes #1810
Diffstat (limited to 'main')
-rw-r--r--main/libarchive/APKBUILD17
-rw-r--r--main/libarchive/CVE-2013-0211.patch32
2 files changed, 46 insertions, 3 deletions
diff --git a/main/libarchive/APKBUILD b/main/libarchive/APKBUILD
index e9e1d26597..51f8ffabc7 100644
--- a/main/libarchive/APKBUILD
+++ b/main/libarchive/APKBUILD
@@ -1,7 +1,7 @@
# Maintainer: Natanael Copa <ncopa@alpinelinux.org>
pkgname=libarchive
pkgver=3.0.2
-pkgrel=0
+pkgrel=1
pkgdesc="library that can create and read several streaming archive formats"
url="http://libarchive.googlecode.com/"
arch="all"
@@ -10,9 +10,19 @@ depends=""
subpackages="$pkgname-dev $pkgname-doc $pkgname-tools"
makedepends="zlib-dev bzip2-dev xz-dev acl-dev openssl-dev expat-dev"
depends_dev="$makedepends"
-source="http://libarchive.googlecode.com/files/libarchive-$pkgver.tar.gz"
+source="http://www.libarchive.org/downloads/libarchive-$pkgver.tar.gz
+ CVE-2013-0211.patch"
_builddir="$srcdir"/$pkgname-$pkgver
+prepare() {
+ cd "$_builddir"
+ for i in $source; do
+ case $i in
+ *.patch) msg $i; patch -p1 -i "$srcdir"/$i || return 1;;
+ esac
+ done
+}
+
build () {
cd "$_builddir"
./configure --prefix=/usr --without-xml2
@@ -30,4 +40,5 @@ tools() {
mv "$pkgdir"/usr/bin "$subpkgdir"/usr/
}
-md5sums="4df33cb107c9702c80473e0794ddf833 libarchive-3.0.2.tar.gz"
+md5sums="4df33cb107c9702c80473e0794ddf833 libarchive-3.0.2.tar.gz
+fc5f5158d414e3a7e9f085d8d1470014 CVE-2013-0211.patch"
diff --git a/main/libarchive/CVE-2013-0211.patch b/main/libarchive/CVE-2013-0211.patch
new file mode 100644
index 0000000000..c927a860e2
--- /dev/null
+++ b/main/libarchive/CVE-2013-0211.patch
@@ -0,0 +1,32 @@
+From 22531545514043e04633e1c015c7540b9de9dbe4 Mon Sep 17 00:00:00 2001
+From: Tim Kientzle <kientzle@acm.org>
+Date: Fri, 22 Mar 2013 23:48:41 -0700
+Subject: [PATCH] Limit write requests to at most INT_MAX. This prevents a
+ certain common programming error (passing -1 to write) from leading to other
+ problems deeper in the library.
+
+---
+ libarchive/archive_write.c | 5 +++++
+ 1 file changed, 5 insertions(+)
+
+diff --git a/libarchive/archive_write.c b/libarchive/archive_write.c
+index eede5e0..be85621 100644
+--- a/libarchive/archive_write.c
++++ b/libarchive/archive_write.c
+@@ -673,8 +673,13 @@ struct archive_write_filter *
+ _archive_write_data(struct archive *_a, const void *buff, size_t s)
+ {
+ struct archive_write *a = (struct archive_write *)_a;
++ const size_t max_write = INT_MAX;
++
+ archive_check_magic(&a->archive, ARCHIVE_WRITE_MAGIC,
+ ARCHIVE_STATE_DATA, "archive_write_data");
++ /* In particular, this catches attempts to pass negative values. */
++ if (s > max_write)
++ s = max_write;
+ archive_clear_error(&a->archive);
+ return ((a->format_write_data)(a, buff, s));
+ }
+--
+1.8.1.6
+